package com.bizmatics.common.mvc.utils;

import org.springframework.jdbc.core.namedparam.BeanPropertySqlParameterSource;
import org.springframework.jdbc.core.namedparam.NamedParameterJdbcTemplate;

import java.util.List;

/**
 * @author barry chen
 * @date 2020/12/10 4:41 下午
 */
public final class JdbcUtils {
    private JdbcUtils() {
    }

    /**
     * 批量执行sql. 可用于insert/update/delete
     *
     * @param jdbctemplate
     * @param sql
     * @param entityList
     * @return
     */
    public static int[] batchUpdate(NamedParameterJdbcTemplate jdbctemplate, String sql, List<?> entityList) {
        BeanPropertySqlParameterSource[] notifyParamArray = new BeanPropertySqlParameterSource[entityList.size()];
        for (int i = 0; i < entityList.size(); i++) {
            notifyParamArray[i] = new BeanPropertySqlParameterSource(entityList.get(i));
        }
        return jdbctemplate.batchUpdate(sql, notifyParamArray);
    }
}
