package com.bizmatics.common.spring.config.id;

import com.bizmatics.common.core.util.id.IdWorkerContainer;
import com.bizmatics.common.spring.annotion.ConditionalOnPropertyNotEmpty;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.context.properties.EnableConfigurationProperties;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;
import org.springframework.context.annotation.Primary;

@ConditionalOnPropertyNotEmpty("id.workerId")
@Configuration
@EnableConfigurationProperties(IdWorkerConfigProperties.class)
public class IdWorkerAutoConfiguration {

    @Autowired
    private IdWorkerConfigProperties properties;

    @Bean
    @Primary
    public IdWorkerContainer idWorkerContainer() {
        Long workerId = properties.getWorkerId();
        return new IdWorkerContainer(workerId);
    }
}
