package com.bizmatics.mhfire.controller.web;

import com.bizmatics.common.core.bean.ApiResult;
import com.bizmatics.mhfire.service.AlFsdAllService;
import com.bizmatics.mhfire.service.vo.AlFsdAllCsVO;
import com.bizmatics.mhfire.service.vo.AlFsdAllVO;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import java.util.Date;

/**
 * 行政许可-消防安检申报总
 * @author yq
 * @date 2021/5/25 17:14
 */
@RestController
@RequestMapping("/alFsdAll")
public class AlFsdAllControllerWeb {

    @Autowired
    private AlFsdAllService alFsdAllService;


    /**
     * 获取行政许可的检查，受理，出文数量
     * @param startTime 开始时间
     * @param endTime 结束时间
     * @return
     */
    @GetMapping("/alFsdAllNumber")
    public ApiResult<AlFsdAllVO> alFsdAllNumber(@RequestParam(required = false) Date startTime,
                                                 @RequestParam(required = false) Date endTime){
        return ApiResult.success(alFsdAllService.getAlFsdAllNumber(startTime,endTime));
    }
    /**
     * 获取开业检查记录的汇总
     * @return
     */
    @GetMapping("/csCount")
    public ApiResult<AlFsdAllCsVO> getCsCount(){
        return ApiResult.success(alFsdAllService.getCsCount());
    }
}
