package com.bizmatics.mhfire.controller.web;

import com.bizmatics.common.core.bean.ApiResult;
import com.bizmatics.common.core.bean.CommonPage;
import com.bizmatics.mhfire.model.FireSite;
import com.bizmatics.mhfire.service.FireSiteService;
import com.bizmatics.mhfire.service.vo.FireSiteDutyVO;
import com.bizmatics.mhfire.service.vo.FireSiteVO;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.List;

/**
 * 消防站点
 * @author yq
 * @date 2021/5/31 10:13
 */
@RestController
@RequestMapping("/fireSite")
public class FireSiteControllerWeb {

    @Autowired
    private FireSiteService fireSiteService;


    /**
     * 分页
     * @param current 页数
     * @param size 条数
     * @return
     */
    @GetMapping("/page")
    public ApiResult<CommonPage<FireSite>> page(@RequestParam Integer current,
                                                @RequestParam Integer size){
        return ApiResult.success(fireSiteService.page(current, size));
    }


    /**
     * get one
     * @param id id
     * @return
     */
    @GetMapping("/one")
    public ApiResult<FireSiteVO> getOne(@RequestParam String id){
        return ApiResult.success(fireSiteService.getOne(id));
    }

    /**
     * 站点执勤实力
     * @param fireSiteId
     * @return
     */
    @GetMapping("/fireSiteDuty")
    public ApiResult<List<FireSiteDutyVO>> getFireSiteDuty(@RequestParam String fireSiteId){
        return ApiResult.success(fireSiteService.getFireSiteDuty(fireSiteId));
    }

    @GetMapping("/addList")
    public void addList(@RequestBody List<FireSite> fireSite){
        fireSiteService.saveBatch(fireSite);
    }
}
