package com.bizmatics.mhfire.controller.web;

import com.bizmatics.common.core.bean.ApiResult;
import com.bizmatics.common.core.bean.CommonPage;
import com.bizmatics.mhfire.persistence.mapper.po.FireWaterPO;
import com.bizmatics.mhfire.service.FireWaterService;
import com.bizmatics.mhfire.service.vo.FireWaterStatisticsVO;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import java.util.Date;

/**
 * 水源模块
 * @author yq
 * @date 2021/5/31 9:35
 */
@RestController
@RequestMapping("/fireWater")
public class FireWaterControllerWeb {
    @Autowired
    private FireWaterService fireWaterService;




    /**
     * 获取水源详细信息
     * @param id 水源id
     * @return
     */
    @GetMapping("/one")
    public ApiResult<FireWaterPO> getOne(@RequestParam String id){
        return ApiResult.success(fireWaterService.getOne(id));
    }


    /**
     * 分页
     * @param current 页数
     * @param size  条数
     * @param startTime 开始时间
     * @param endTime 结束时间
     * @return
     */
    @GetMapping("/page")
    public ApiResult<CommonPage<FireWaterPO>> page(@RequestParam Integer current,
                                                   @RequestParam Integer size,
                                                   @RequestParam(required = false)Date startTime,
                                                   @RequestParam(required = false)Date endTime){
        return ApiResult.success(fireWaterService.page(current,size,startTime,endTime));
    }

    /**
     * 水源统计
     * @param startTime 开始时间
     * @param endTime   结束时间
     * @return
     */
    @GetMapping("/fireWaterStatistics")
    public ApiResult<FireWaterStatisticsVO> getFireWaterStatistics(@RequestParam(required = false) Date startTime,
                                                                   @RequestParam(required = false) Date endTime){
        return ApiResult.success(fireWaterService.getFireWaterStatistics(startTime,endTime));
    }
}
