package com.bizmatics.mhfire.controller.web;

import com.bizmatics.common.core.bean.ApiResult;
import com.bizmatics.mhfire.service.ReportComplaintService;
import com.bizmatics.mhfire.service.vo.ReportComplaintVO;
import com.bizmatics.mhfire.service.vo.ReportStatisticsVO;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import java.util.Date;
import java.util.List;

/**
 * 举报投诉
 * @author yq
 * @date 2021/5/31 9:21
 */
@RestController
@RequestMapping("/reportComplaint")
public class ReportComplaintControllerWeb {


    @Autowired
    private ReportComplaintService reportComplaintService;



    /**
     * 举报投诉分类汇总
     * @param startTime 开始时间
     * @param endTime   结束时间
     * @return
     */
    @GetMapping("/reportStatistics")
    public ApiResult<ReportStatisticsVO> getReportStatistics(@RequestParam(required = false) Date startTime,
                                                             @RequestParam(required = false) Date endTime){
        return ApiResult.success(reportComplaintService.getReportStatistics(startTime, endTime));
    }

    /**
     * 举报情况信息
     * @return
     */
    /**
     * 举报情况信息
     * @param startTime 开始时间
     * @param endTime   结束时间
     * @return
     */
    @GetMapping("/reportComplaint")
    public ApiResult<List<ReportComplaintVO>> getReportComplaint(@RequestParam(required = false) Date startTime,
                                                                @RequestParam(required = false) Date endTime){
        return ApiResult.success(reportComplaintService.getReportComplaint(startTime, endTime));
    }

}
