package com.bizmatics.mhfire.controller.web;

import com.bizmatics.common.core.bean.ApiResult;
import com.bizmatics.mhfire.persistence.mapper.po.UnitBeOnDutyPO;
import com.bizmatics.mhfire.service.UnitBeOnDutyService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import java.util.Date;
import java.util.List;

/**
 * 支队值班
 * @author yq
 * @date 2021/5/31 9:28
 */
@RestController
@RequestMapping("/unitBeOnDuty")
public class UnitBeOnDutyControllerWeb {

    @Autowired
    private UnitBeOnDutyService unitBeOnDutyService;


    /**
     * 今日值班表
     * @return
     */
    @GetMapping("/one")
    public ApiResult<List<UnitBeOnDutyPO>> getOneByToday(){
        return ApiResult.success(unitBeOnDutyService.getOneByToday());
    }


    @GetMapping("/list")
    public ApiResult<List<List<UnitBeOnDutyPO>>> list(@RequestParam(required = false) Date startTime,
                                                @RequestParam(required = false) Date endTime){
        return ApiResult.success(unitBeOnDutyService.list(startTime,endTime));
    }

}
