package com.bizmatics.mhfire.controller.web;

import com.bizmatics.common.core.bean.ApiResult;
import com.bizmatics.common.core.bean.CommonPage;
import com.bizmatics.mhfire.persistence.mapper.po.UnitPO;
import com.bizmatics.mhfire.service.UnitService;
import com.bizmatics.mhfire.service.vo.UnitAlCheckVO;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.Date;

/**
 * 单位信息
 * @author yq
 * @date 2021/5/28 17:44
 */
@RestController
@RequestMapping("/unit")
public class UnitControllerWeb {

    @Autowired
    private UnitService unitService;


    /**
     * 获取单个单位信息
     * @return
     */
    @GetMapping("/one")
    public ApiResult<UnitPO> getOne(@RequestBody UnitPO unitPo){
        return ApiResult.success(unitService.getOne(unitPo));
    }

    /**
     * 分页
     * @param current 页数
     * @param size 条数
     * @return
     */
    @GetMapping("/page")
    public ApiResult<CommonPage<UnitPO>> page(@RequestParam Integer current,
                                              @RequestParam Integer size){
        return ApiResult.success(unitService.page(current,size));
    }


    /**
     * 单位信息及执法情况和历史检查记录
     * @param unitId  单位ID
     * @param startTime 开始时间
     * @param endTime 结束时间
     * @return
     */
    @GetMapping("/unitAlCheck")
    public ApiResult<UnitAlCheckVO> getUnitAlCheck(@RequestParam String unitId,
                                                   @RequestParam(required = false) Date startTime,
                                                   @RequestParam(required = false) Date endTime){
        return ApiResult.success(unitService.getUnitAlCheck(unitId,startTime,endTime));
    }
}
