package com.bizmatics.mhfire.controller.web.bulehelp;


import com.bizmatics.common.core.bean.ApiResult;
import com.bizmatics.common.core.bean.CommonPage;
import com.bizmatics.mhfire.model.bulehelp.BmfwFeedback;
import com.bizmatics.mhfire.model.bulehelp.BmfwLawsCatalog;
import com.bizmatics.mhfire.service.bulehelp.BmfwLawsCatalogService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;

import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

/**
 * <p>
 *  法规目录表
 * </p>
 *
 * @author liangcy
 * @since 2021-06-15
 */
@RestController
@RequestMapping("/bule/bmfwLawsCatalog")
public class BmfwLawsCatalogController {

    @Autowired
    private BmfwLawsCatalogService bmfwLawsCatalogService;


    /**
     * 分页
     * @param current 页数
     * @param size 条数
     * @param name 名称
     * @param lawsId 法律名称
     * @return
     */
    @GetMapping("/page")
    public ApiResult<CommonPage<BmfwLawsCatalog>> page(@RequestParam Integer current,
                                                       @RequestParam Integer size,
                                                       @RequestParam(required = false) String name,
                                                       @RequestParam(required = false) String lawsId){
        return ApiResult.success(bmfwLawsCatalogService.page(current, size, name,lawsId));
    }

}

