package com.bizmatics.mhfire.controller.web.bulehelp;


import com.bizmatics.common.core.bean.ApiResult;
import com.bizmatics.common.core.bean.CommonPage;
import com.bizmatics.mhfire.model.bulehelp.BmfwLawsCatalog;
import com.bizmatics.mhfire.model.bulehelp.BmfwLawsCatalogInfo;
import com.bizmatics.mhfire.service.bulehelp.BmfwLawsCatalogInfoService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;

import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

/**
 * <p>
 *  法规详情表
 * </p>
 *
 * @author liangcy
 * @since 2021-06-15
 */
@RestController
@RequestMapping("/bule/bmfwLawsCatalogInfo")
public class BmfwLawsCatalogInfoController {

    @Autowired
    private BmfwLawsCatalogInfoService bmfwLawsCatalogInfoService;


    /**
     * 分页
     * @param current 页数
     * @param size 条数
     * @param param value
     * @param catalogId 法规目录id
     * @return
     */
    @GetMapping("/page")
    public ApiResult<CommonPage<BmfwLawsCatalogInfo>> page(@RequestParam Integer current,
                                                           @RequestParam Integer size,
                                                           @RequestParam(required = false) String param,
                                                           @RequestParam(required = false) Integer catalogId){
        return ApiResult.success(bmfwLawsCatalogInfoService.page(current, size, param,catalogId));
    }

}

