package com.bizmatics.mhfire.controller.web.bulehelp;


import com.bizmatics.common.core.bean.ApiResult;
import com.bizmatics.common.core.bean.CommonPage;
import com.bizmatics.mhfire.model.bulehelp.RobotQuestionMessageRecord;
import com.bizmatics.mhfire.service.bulehelp.RobotQuestionMessageRecordService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import java.util.Date;
import java.util.List;

/**
 * <p>
 *  留言记录信息
 * </p>
 *
 * @author yq
 * @since 2021-06-15
 */
@RestController
@RequestMapping("/bule/robotQuestionMessageRecord")
public class RobotQuestionMessageRecordController {

    @Autowired
    private RobotQuestionMessageRecordService robotQuestionMessageRecordService;

    /**
     * 分页
     * @param current 页数
     * @param size 条数
     * @return
     */
    @GetMapping("/page")
    public ApiResult<CommonPage<RobotQuestionMessageRecord>> page(@RequestParam Integer current,
                                                            @RequestParam Integer size){
        return ApiResult.success(robotQuestionMessageRecordService.page(current, size));
    }

    /**
     * 获取月份图标信息
     * @return
     */
    @GetMapping("/ico")
    public ApiResult<List<Integer>> getIco(){
        return ApiResult.success(robotQuestionMessageRecordService.getIco());
    }

    /**
     * 获取总数
     * @param startTime 开始时间
     * @param endTime 结束时间
     * @return
     */
    @GetMapping("/count")
    public ApiResult<Integer> getCount(@RequestParam(required = false) Date startTime,
                                       @RequestParam(required = false) Date endTime){
        return ApiResult.success(robotQuestionMessageRecordService.getCount(startTime,endTime));
    }
}

