package com.bizmatics.mhfire.persistence.mapper;

import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.bizmatics.mhfire.persistence.mapper.po.FireStatisticsPO;
import org.apache.ibatis.annotations.Param;
import org.springframework.stereotype.Repository;

import java.util.Date;
import java.util.List;
import java.util.Map;

/**
 * @author yq
 * @date 2021/5/28 9:16
 * 火灾统计模块
 */
@Repository
public interface FireStatisticsMapper {


    /**
     * 统计火灾数量
     * @param startTime
     * @param endTime
     * @param fireAddress
     * @param level
     * @param unitId
     * @return
     */
    Integer selectCount(@Param("startTime") Date startTime,
                        @Param("endTime") Date endTime,
                        @Param("fireAddress") String fireAddress,
                        @Param("level") String level,
                        @Param("unitId") String unitId,
                        @Param("region") String region);



    /**
     * 分页查询
     * @param page
     * @param startTime
     * @param endTime
     * @param address
     * @return
     */
    Page<Map<String,String>> page(IPage<Map<String,String>> page,
                                  @Param("startTime") Date startTime,
                                  @Param("endTime")Date endTime,
                                  @Param("address")String address);


    /**
     * list
     * @param startTime
     * @param endTime
     * @param address
     * @return
     */
    List<Map<String,String>> list(@Param("startTime") Date startTime,
                                  @Param("endTime")Date endTime,
                                  @Param("address")String address);


    List<Map<String,String>> distanceList(@Param("longitude") Double longitude,
                                          @Param("latitude")Double latitude,
                                          @Param("startTime") Date startTime,
                                          @Param("endTime")Date endTime);


    Map<String,String> getOne(@Param("id") String id);


    List<String> groupByCause();


    List<String> getAddress();


    Date selectMaxDate();

    Date selectMinDate();

    List<Map<String,Object>> selectCountByDate(@Param("startTime") Date startTime,
                                   @Param("endTime") Date endTime,
                                   @Param("address") String address,
                                   @Param("fireType") String fireType);



    Map<String,Double> selectAvgAndSum(@Param("startTime") Date startTime,
                                 @Param("endTime") Date endTime,
                                 @Param("region") String region,
                                 @Param("fireType") String fireType,
                                 @Param("unitId") String unitId);


    int updateList(List<FireStatisticsPO> list);
}
