package com.bizmatics.mhfire.service;

import com.bizmatics.common.core.bean.CommonPage;
import com.bizmatics.common.mvc.base.CrudService;
import com.bizmatics.mhfire.model.Alert;
import com.bizmatics.mhfire.service.vo.AlertMapVO;
import com.bizmatics.mhfire.service.vo.AlertStatisticsVO;

import java.util.Date;
import java.util.List;
import java.util.Map;

/**
 * @author yq
 * @date 2021/5/28 14:52
 * 警情
 */
public interface AlertService  extends CrudService<Alert> {


    /**
     * 按小时统计警情
     * @return
     */
    Map<String, List<AlertStatisticsVO>> getAlertStatisticsByHouse(Date startTime,Date endTime);



    /**
     * 按月份统计警情
     * @return
     */
    Map<String, List<AlertStatisticsVO>> getAlertStatisticsByMonth(Date startTime,Date endTime);


    /**
     * 警情详细信息
     * @param current
     * @param size
     * @param startTime
     * @param endTime
     * @return
     */
    CommonPage<Alert> page(Integer current, Integer size, Date startTime, Date endTime);

    CommonPage<AlertMapVO> pageMap(Integer current, Integer size, Date startTime, Date endTime);
    /**
     * 查询不同警情(社会救助，警情，火灾)的占比
     * @param startTime
     * @param endTime
     * @return
     */
    List<AlertStatisticsVO> getAlertStatistics(Date startTime, Date endTime);

    Alert getOne(String id);


}
