package com.bizmatics.mhfire.service;

import com.bizmatics.common.core.bean.CommonPage;
import com.bizmatics.mhfire.persistence.mapper.po.FireStatisticsPO;
import com.bizmatics.mhfire.service.vo.FireBubbleVO;
import com.bizmatics.mhfire.service.vo.FireLevelRatioVO;
import com.bizmatics.mhfire.service.vo.FireUnitPoliceVO;

import java.util.Date;
import java.util.List;

/**
 * @author yq
 * @date 2021/5/28 9:32
 * 火灾统计
 */
public interface FireStatisticsService {


    /**
     * 根据年份和地址查看12月份的火灾统计
     * @param startTime
     * @param endTime
     * @param address
     * @return
     */
    List<Object> getFireCountByData(Date startTime,Date endTime,String address,String fireType);


    /**
     * 分页
     * @param current
     * @param size
     * @param startTime
     * @param endTime
     * @return
     */
    CommonPage<FireStatisticsPO> page(Integer current, Integer size, Date startTime, Date endTime, String address);


    List<FireStatisticsPO> list(Date startTime, Date endTime, String address);

    /**
     * 计算精度维度差
     * @param longitude
     * @param latitude
     * @return
     */
    List<FireStatisticsPO> distanceList(Double longitude, Double latitude, Date startTime, Date endTime);
    /**
     * getOne
     * @param id
     * @return
     */
    FireStatisticsPO getOne(String id);


    /**
     * 火灾-单位-出警信息
     * @param id
     * @return
     */
    FireUnitPoliceVO getFireUnitPolice(String id);


    /**
     * 火灾原因占比
     * @param startTime
     * @param endTime
     * @param address
     * @return
     */
    List<FireLevelRatioVO> getGroupByLevel(Date startTime, Date endTime, String address);


    /**
     * 火灾分类
     * @return
     */
    List<String> getFireType();

    /**
     * 火灾行政区域
      * @return
     */
    List<String> getAddress();


    /**
     * 火灾气泡图
     * @param startTime
     * @param endTime
     * @param fireType
     * @param unitId
     * @return
     */
    List<FireBubbleVO> getAvgAndSum(Date startTime, Date endTime, String fireType, String unitId);


}
