package com.bizmatics.mhfire.service.bulehelp.impl;


import com.baomidou.dynamic.datasource.annotation.DS;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.bizmatics.common.core.bean.CommonPage;
import com.bizmatics.common.core.util.StringUtils;
import com.bizmatics.common.mvc.base.AbstractCrudService;
import com.bizmatics.mhfire.model.bulehelp.BmfwEvent;
import com.bizmatics.mhfire.persistence.mapper.bulehelp.BmfwEventMapper;
import com.bizmatics.mhfire.service.bulehelp.BmfwEventService;

import org.springframework.stereotype.Service;

import java.util.ArrayList;

/**
 * <p>
 *  项目申报记录表
 * </p>
 *
 * @author yq
 * @since 2021-06-15
 */
@DS("bulehelp")
@Service
public class BmfwEventServiceImpl extends AbstractCrudService<BmfwEventMapper, BmfwEvent> implements BmfwEventService {

    @Override
    public CommonPage<BmfwEvent> page(Integer current,Integer size,String unit) {
        LambdaQueryWrapper<BmfwEvent> productLambdaQueryWrapper = Wrappers.lambdaQuery(BmfwEvent.class);
        if (StringUtils.isNotBlank(unit)) {
            productLambdaQueryWrapper.and(wrapper -> wrapper.like(BmfwEvent::getUnit, unit)
                    .or()
                    .like(BmfwEvent::getNo, unit)
                    .or()
                    .like(BmfwEvent::getClassify, unit)
                    .or()
                    .like(BmfwEvent::getPrivateName, unit)
                    .or()
                    .like(BmfwEvent::getAddress, unit)
                    .or()
                    .like(BmfwEvent::getUsername, unit));
        }
        IPage<BmfwEvent> page = new Page<>(current, size);
        page = baseMapper.selectPage(page, productLambdaQueryWrapper);
        return this.ToCommonPage(page);
    }
}
