package com.bizmatics.mhfire.service.bulehelp.impl;


import com.baomidou.dynamic.datasource.annotation.DS;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.bizmatics.common.core.bean.CommonPage;
import com.bizmatics.common.core.util.StringUtils;
import com.bizmatics.common.mvc.base.AbstractCrudService;
import com.bizmatics.mhfire.model.bulehelp.BmfwFeedback;
import com.bizmatics.mhfire.model.bulehelp.BmfwLawsCatalog;
import com.bizmatics.mhfire.model.bulehelp.BmfwLawsCatalogInfo;
import com.bizmatics.mhfire.persistence.mapper.bulehelp.BmfwLawsCatalogInfoMapper;
import com.bizmatics.mhfire.service.bulehelp.BmfwLawsCatalogInfoService;
import com.bizmatics.mhfire.service.bulehelp.BmfwLawsCatalogService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.ArrayList;

/**
 * <p>
 *  服务实现类
 * </p>
 *
 * @author liangcy
 * @since 2021-06-15
 */
@DS("bulehelp")
@Service
public class BmfwLawsCatalogInfoServiceImpl extends AbstractCrudService<BmfwLawsCatalogInfoMapper, BmfwLawsCatalogInfo> implements BmfwLawsCatalogInfoService {
    @Autowired
    private BmfwLawsCatalogService bmfwLawsCatalogService;

    @Override
    public CommonPage<BmfwLawsCatalogInfo> page(Integer current,Integer size,String param,Integer catalogId) {
        LambdaQueryWrapper<BmfwLawsCatalogInfo> productLambdaQueryWrapper = Wrappers.lambdaQuery(BmfwLawsCatalogInfo.class)
                .like(StringUtils.isNotBlank(param), BmfwLawsCatalogInfo::getValue, param)
                .eq(null != catalogId,BmfwLawsCatalogInfo::getCatalogId,catalogId);
        IPage<BmfwLawsCatalogInfo> page = new Page<>(current, size);
        page = baseMapper.selectPage(page, productLambdaQueryWrapper);
        for (BmfwLawsCatalogInfo bmfwLawsCatalogInfo:page.getRecords()) {
            bmfwLawsCatalogInfo.setBmfwLawsCatalog(bmfwLawsCatalogService.getById(bmfwLawsCatalogInfo.getCatalogId()));
        }
        return this.ToCommonPage(page);
    }
}
