package com.bizmatics.mhfire.service.bulehelp.impl;


import com.baomidou.dynamic.datasource.annotation.DS;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.bizmatics.common.core.bean.CommonPage;
import com.bizmatics.common.core.util.StringUtils;
import com.bizmatics.common.mvc.base.AbstractCrudService;
import com.bizmatics.mhfire.model.bulehelp.BmfwFeedback;
import com.bizmatics.mhfire.model.bulehelp.BmfwLawsCatalog;
import com.bizmatics.mhfire.persistence.mapper.bulehelp.BmfwLawsCatalogMapper;
import com.bizmatics.mhfire.service.bulehelp.BmfwLawsCatalogService;
import org.springframework.stereotype.Service;

import java.util.ArrayList;

/**
 * <p>
 *  服务实现类
 * </p>
 *
 * @author liangcy
 * @since 2021-06-15
 */
@DS("bulehelp")
@Service
public class BmfwLawsCatalogServiceImpl extends AbstractCrudService<BmfwLawsCatalogMapper, BmfwLawsCatalog> implements BmfwLawsCatalogService {

    @Override
    public CommonPage<BmfwLawsCatalog> page(Integer current,Integer size,String name,String lawsId) {
        LambdaQueryWrapper<BmfwLawsCatalog> productLambdaQueryWrapper = Wrappers.lambdaQuery(BmfwLawsCatalog.class)
                .like(StringUtils.isNotBlank(name), BmfwLawsCatalog::getName, name)
                .eq(StringUtils.isNotBlank(lawsId), BmfwLawsCatalog::getLawsId, lawsId);
        IPage<BmfwLawsCatalog> page = new Page<>(current, size);
        page = baseMapper.selectPage(page, productLambdaQueryWrapper);
        return this.ToCommonPage(page);
    }
}
