package com.bizmatics.mhfire.service.bulehelp.impl;


import com.baomidou.dynamic.datasource.annotation.DS;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.bizmatics.common.core.bean.CommonPage;
import com.bizmatics.common.core.util.DateUtils;
import com.bizmatics.common.mvc.base.AbstractCrudService;
import com.bizmatics.mhfire.model.bulehelp.RobotQuestionMessageRecord;
import com.bizmatics.mhfire.persistence.mapper.bulehelp.RobotQuestionMessageRecordMapper;
import com.bizmatics.mhfire.service.bulehelp.RobotQuestionMessageRecordService;
import com.bizmatics.mhfire.service.bulehelp.RobotQuestionMessageService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;
import java.util.Optional;

/**
 * <p>
 *  服务实现类
 * </p>
 *
 * @author liangcy
 * @since 2021-06-15
 */
@DS("bulehelp")
@Service
public class RobotQuestionMessageRecordServiceImpl extends AbstractCrudService<RobotQuestionMessageRecordMapper, RobotQuestionMessageRecord> implements RobotQuestionMessageRecordService {
    @Autowired
    private RobotQuestionMessageService robotQuestionMessageService;
    @Override
    public CommonPage<RobotQuestionMessageRecord> page(Integer current,Integer size) {
        LambdaQueryWrapper<RobotQuestionMessageRecord> productLambdaQueryWrapper = Wrappers.lambdaQuery(RobotQuestionMessageRecord.class);
        IPage<RobotQuestionMessageRecord> page = new Page<>(current, size);
        page = baseMapper.selectPage(page, productLambdaQueryWrapper);
        page.getRecords().forEach(robotQuestionMessageRecord ->
            Optional.ofNullable(robotQuestionMessageRecord.getMessageId())
                    .ifPresent(messageId -> robotQuestionMessageRecord.setRobotQuestionMessage(robotQuestionMessageService.getById(messageId)))
        );
        return this.ToCommonPage(page);
    }
    @Override
    public List<Integer> getIco() {
        List<Integer> list = new ArrayList<>();
        Date date = new Date();
        for (int i = 1; i <= Integer.parseInt(DateUtils.getDay(date)); i++) {
            Date setDays = DateUtils.setDays(date, i);
            Date dayStartTime = DateUtils.getDayStartTime(setDays);
            Date dayEndTime = DateUtils.getDayEndTime(setDays);
            list.add(getCount(dayStartTime,dayEndTime));
        }
        return list;
    }

    @Override
    public Integer getCount(Date startTime,Date endTime) {
        LambdaQueryWrapper<RobotQuestionMessageRecord> queryWrapper = Wrappers.lambdaQuery(RobotQuestionMessageRecord.class);
        if (null != startTime && null != endTime){
            queryWrapper.between(RobotQuestionMessageRecord::getCreateTime,startTime,endTime);
        }
        return this.count(queryWrapper);
    }
}
