package com.bizmatics.mhfire.service.bulehelp.impl;


import com.baomidou.dynamic.datasource.annotation.DS;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.bizmatics.common.core.bean.CommonPage;
import com.bizmatics.common.core.util.DateUtils;
import com.bizmatics.common.core.util.StringUtils;
import com.bizmatics.common.mvc.base.AbstractCrudService;
import com.bizmatics.mhfire.model.bulehelp.RobotQuestionMessage;
import com.bizmatics.mhfire.persistence.mapper.bulehelp.RobotQuestionMessageMapper;
import com.bizmatics.mhfire.service.bulehelp.RobotQuestionMessageService;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;

/**
 * <p>
 *  服务实现类
 * </p>
 *
 * @author liangcy
 * @since 2021-06-15
 */
@DS("bulehelp")
@Service
public class RobotQuestionMessageServiceImpl extends AbstractCrudService<RobotQuestionMessageMapper, RobotQuestionMessage> implements RobotQuestionMessageService {

    @Override
    public CommonPage<RobotQuestionMessage> page(Integer current,Integer size,String param) {
        LambdaQueryWrapper<RobotQuestionMessage> productLambdaQueryWrapper = Wrappers.lambdaQuery(RobotQuestionMessage.class)
                .like(StringUtils.isNotBlank(param), RobotQuestionMessage::getClassify, param);
        IPage<RobotQuestionMessage> page = new Page<>(current, size);
        page = baseMapper.selectPage(page, productLambdaQueryWrapper);
        return this.ToCommonPage(page);
    }

    @Override
    public List<Integer> getIco() {
        List<Integer> list = new ArrayList<>();
        Date date = new Date();
        for (int i = 1; i <= Integer.parseInt(DateUtils.getDay(date)); i++) {
            Date setDays = DateUtils.setDays(date, i);
            Date dayStartTime = DateUtils.getDayStartTime(setDays);
            Date dayEndTime = DateUtils.getDayEndTime(setDays);
            list.add(getCount(dayStartTime,dayEndTime));
        }
        return list;
    }

    @Override
    public Integer getCount(Date startTime,Date endTime) {
        LambdaQueryWrapper<RobotQuestionMessage> queryWrapper = Wrappers.lambdaQuery(RobotQuestionMessage.class);
        if (null != startTime && null != endTime){
            queryWrapper.between(RobotQuestionMessage::getCreateTime,startTime,endTime);
        }
        return this.count(queryWrapper);
    }
}
