package com.bizmatics.mhfire.service.impl;

import com.bizmatics.mhfire.persistence.mapper.AlFsdDisagreeMapper;
import com.bizmatics.mhfire.persistence.mapper.AlFsdSeqMapper;
import com.bizmatics.mhfire.persistence.mapper.AlFsdVoucherMapper;
import com.bizmatics.mhfire.persistence.mapper.BsSupervisionAllMapper;
import com.bizmatics.mhfire.service.AlFsdAllService;
import com.bizmatics.mhfire.service.enums.BsSaOneCode;
import com.bizmatics.mhfire.service.enums.BsSaTwoCode;
import com.bizmatics.mhfire.service.util.Arith;
import com.bizmatics.mhfire.service.vo.AlFsdAllCsVO;
import com.bizmatics.mhfire.service.vo.AlFsdAllVO;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.Date;

/**
 * @author yq
 * @date 2021/5/25 16:49
 */
@Service
public class AlFsdAllServiceImpl implements AlFsdAllService {

    @Autowired
    private AlFsdSeqMapper alFsdSeqMapper;
    @Autowired
    private AlFsdVoucherMapper alFsdVoucherMapper;
    @Autowired
    private AlFsdDisagreeMapper alFsdDisagreeMapper;

    @Autowired
    private BsSupervisionAllMapper bsSupervisionAllMapper;

    @Override
    public AlFsdAllVO getAlFsdAllNumber(Date startTime, Date endTime) {
        AlFsdAllVO alFsdAllVo = new AlFsdAllVO();
        alFsdAllVo.setAcceptNumber(alFsdVoucherMapper.selectCount(startTime,endTime));
        alFsdAllVo.setCheckNumber(bsSupervisionAllMapper.selectCount
                (BsSaOneCode.SAFETY_CHECK.getLetter(), BsSaTwoCode.C_S.getLetter(),startTime,endTime,null,null));
        //行政许可安全检查合格证
        Integer seqCount = alFsdSeqMapper.selectCount(startTime, endTime);
        //行政许可-消防安检申报不同意
        Integer disagreeCount = alFsdDisagreeMapper.selectCount(startTime, endTime);
        alFsdAllVo.setArticleNumber(seqCount+disagreeCount);
        alFsdAllVo.setQualifiedRadio(Arith.div(seqCount,seqCount+disagreeCount));
        return alFsdAllVo;
    }

    @Override
    public AlFsdAllCsVO getCsCount() {
        AlFsdAllCsVO alFsdAllCsVO = new AlFsdAllCsVO();
        Integer count = bsSupervisionAllMapper.selectCount
                (BsSaOneCode.SAFETY_CHECK.getLetter(), BsSaTwoCode.C_S.getLetter(), null, null, null, null);
        Integer noQualified = bsSupervisionAllMapper.selectCount
                (BsSaOneCode.SAFETY_CHECK.getLetter(), BsSaTwoCode.C_S.getLetter(), null, null, null, "2");
        alFsdAllCsVO.setCount(count);
        alFsdAllCsVO.setNoQualified(noQualified);
        alFsdAllCsVO.setQualified(count-noQualified);
        return alFsdAllCsVO;
    }
}
