package com.bizmatics.mhfire.service.impl;

import com.bizmatics.mhfire.persistence.mapper.BsSupervisionAllMapper;
import com.bizmatics.mhfire.persistence.mapper.po.BsSupervisionAllPO;
import com.bizmatics.mhfire.service.BsSupervisionAllService;
import net.sf.ehcache.search.parser.MAggregate;
import org.apache.ibatis.annotations.Param;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.Map;
import java.util.Optional;

/**
 * @author yq
 * @date 2021/6/2 10:00
 */
@Service
public class BsSupervisionAllServiceImpl implements BsSupervisionAllService {


    @Autowired
    private BsSupervisionAllMapper bsSupervisionAllMapper;



    @Override
    public BsSupervisionAllPO getByRecentlyOne(String typeOneLetter, String typeTwoLetter) {
        Map<String, String> stringStringMap = bsSupervisionAllMapper.selectByRecentlyOne(typeOneLetter, typeTwoLetter);
        return Optional.ofNullable(stringStringMap).map(this::enhanceBsSupervisionAll).orElse(null);
    }




    public BsSupervisionAllPO enhanceBsSupervisionAll(Map<String,String> map){
        BsSupervisionAllPO bsSupervisionAllPo = new BsSupervisionAllPO();
        bsSupervisionAllPo.setId(map.get("ID"));
        bsSupervisionAllPo.setProductId(map.get("项目编号"));
        bsSupervisionAllPo.setProductName(map.get("项目名称"));
        bsSupervisionAllPo.setProductUnitId(map.get("项目单位ID"));
        bsSupervisionAllPo.setProductUnitName(map.get("项目单位名称"));
        bsSupervisionAllPo.setProductUnitAddress(map.get("项目单位地址"));
        bsSupervisionAllPo.setUnitType(map.get("监管单位类别（重点单位等）"));
        bsSupervisionAllPo.setProductTypeOne(map.get("项目分类一"));
        bsSupervisionAllPo.setProductTypeOneLetter(map.get("项目分类型一"));
        bsSupervisionAllPo.setProductTypeTwo(map.get("项目分类二"));
        bsSupervisionAllPo.setProductTypeTwoLetter(map.get("项目分类型二"));
        bsSupervisionAllPo.setProductResult(map.get("项目结果名称"));
        bsSupervisionAllPo.setCompetentId(map.get("主管单位"));
        bsSupervisionAllPo.setCompetentName(map.get("主管单位简称（含大队）"));
        bsSupervisionAllPo.setProductCreatTime(map.get("项目创建日期"));
        bsSupervisionAllPo.setProductCutTime(map.get("截止日期"));
        bsSupervisionAllPo.setProductDisposeTime(map.get("处理时间"));
        bsSupervisionAllPo.setProductEndTime(map.get("项目完成日期"));
        bsSupervisionAllPo.setMastUndertake(map.get("主承办人姓名"));
        bsSupervisionAllPo.setAssistPerson(map.get("协办人姓名"));
        return bsSupervisionAllPo;
    }
}
