package com.bizmatics.mhfire.service.impl;

import com.baomidou.mybatisplus.extension.api.R;
import com.bizmatics.common.core.util.StringUtils;
import com.bizmatics.mhfire.persistence.mapper.ReportComplaintMapper;
import com.bizmatics.mhfire.service.ReportComplaintService;
import com.bizmatics.mhfire.service.util.Arith;
import com.bizmatics.mhfire.service.vo.ReportComplaintVO;
import com.bizmatics.mhfire.service.vo.ReportStatisticsVO;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;
import java.util.Optional;

/**
 * @author yq
 * @date 2021/5/28 17:27
 */
@Service
public class ReportComplaintServiceImpl implements ReportComplaintService {

    @Autowired
    private ReportComplaintMapper reportComplaintMapper;

    @Override
    public ReportStatisticsVO getReportStatistics(Date startTime, Date endTime) {
        //办结数 = 已处理+已归档 处理数 = 总-办结数
        ReportStatisticsVO reportStatisticsVo = new ReportStatisticsVO();
        //总数
        Integer count = reportComplaintMapper.selectCount(null, null, null, null, null);
        reportStatisticsVo.setComplaintNumber(count);
        Integer fireCount = reportComplaintMapper.selectCount(null, null, null, "已归档", null);
        Integer concludeCount = reportComplaintMapper.selectCount(null, null, null, "已办结", null);
        reportStatisticsVo.setConcludeNumber(fireCount+concludeCount);
        reportStatisticsVo.setCheckNumber(count - fireCount - concludeCount);
        Integer satisfactionRateNumber = reportComplaintMapper.selectCount(null, null, null, null, "3");
        reportStatisticsVo.setSatisfactionRate(Arith.div(satisfactionRateNumber,count));
        return reportStatisticsVo;
    }

    @Override
    public List<ReportComplaintVO> getReportComplaint(Date startTime, Date endTime) {
        List<ReportComplaintVO> list = new ArrayList<>();
        List<String> strings = reportComplaintMapper.selectType();
        strings.stream().filter(StringUtils::isNotBlank)
        .forEach(type -> {
            ReportComplaintVO reportComplaintVo = new ReportComplaintVO();
            reportComplaintVo.setType(type);
            reportComplaintVo.setNumber(reportComplaintMapper.selectCount(null,null,type,null,null));
            list.add(reportComplaintVo);
        });
        return list;
    }
}
