package com.bizmatics.mhfire.service.impl;

import com.bizmatics.common.core.exception.BusinessException;
import com.bizmatics.common.core.util.DateUtils;
import com.bizmatics.mhfire.persistence.mapper.SiAeAllMapper;
import com.bizmatics.mhfire.service.SiAeAllService;
import com.bizmatics.mhfire.service.util.Arith;
import com.bizmatics.mhfire.service.vo.SiAeAllVO;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.math.BigDecimal;
import java.nio.file.OpenOption;
import java.util.*;

/**
 * @author yq
 * @date 2021/5/25 15:29
 */
@Service
public class SiAeAllServiceImpl implements SiAeAllService {

    @Autowired
    private SiAeAllMapper siAeAllMapper;
    @Override
    public List<SiAeAllVO> getAeAllCollect(Date startTime, Date endTime) {
        List<SiAeAllVO> allVoS = new ArrayList<>();
        Optional.ofNullable(startTime).orElseThrow(() -> new BusinessException("开始时间不能为空"));
        Optional.ofNullable(endTime).orElseThrow(() -> new BusinessException("结束时间不能为空"));
        Map<String, Double> aeAllCollect = siAeAllMapper.selectAeAllCollect(startTime,endTime);
        //获取同比
        Date upStartTime = DateUtils.addYears(startTime, -1);
        Date upEndTime = DateUtils.addYears(endTime, -1);
        Map<String, Double> upAllCollect = siAeAllMapper.selectAeAllCollect(upStartTime,upEndTime);
        //获取环比
        //获取两个时间天数之差
        int distanceOfTwoDate = DateUtils.getDistanceOfTwoDateNew(startTime, endTime);
        Date linkEndTime = DateUtils.addDays(startTime, -1);
        Date linkStartTime = DateUtils.addDays(linkEndTime, -distanceOfTwoDate);
        Map<String, Double> linkAllCollect = siAeAllMapper.selectAeAllCollect(linkStartTime,linkEndTime);
        Optional.ofNullable(aeAllCollect).ifPresent(aeAll -> {
            for (String type:aeAll.keySet()) {
                SiAeAllVO siAeAllVO = new SiAeAllVO();
                siAeAllVO.setCheckType(type);
                Double radio = aeAll.get(type);
                siAeAllVO.setNumber(radio);
                Double upRadio = 0.00;
                Double linkRadio = 0.00;
                if (0 != radio){
                    upRadio = Optional.ofNullable(upAllCollect).map(up -> up.get(type)).orElse(0.0);
                    siAeAllVO.setSameRatio(Arith.div(upRadio,radio));
                    linkRadio = Optional.ofNullable(linkAllCollect).map(link -> link.get(type)).orElse(0.0);
                    siAeAllVO.setLinkRelativeRatio(Arith.div(linkRadio,radio));
                }else {
                    siAeAllVO.setSameRatio(0.00);
                    siAeAllVO.setLinkRelativeRatio(0.00);
                }
                if (radio.equals(upRadio)){
                    siAeAllVO.setSameStatus(0);
                }else if (radio > upRadio){
                    siAeAllVO.setSameStatus(1);
                }else {
                    siAeAllVO.setSameStatus(2);
                }
                if (radio.equals(linkRadio)){
                    siAeAllVO.setLinkRelativeStatus(0);
                }else if (radio > linkRadio){
                    siAeAllVO.setLinkRelativeStatus(1);
                }else {
                    siAeAllVO.setLinkRelativeStatus(2);
                }
                allVoS.add(siAeAllVO);
            }
        });
        return allVoS;
    }


}
