package com.bizmatics.mhfire.service.impl;

import com.bizmatics.common.core.util.DateUtils;
import com.bizmatics.mhfire.persistence.mapper.UnitBeOnDutyMapper;
import com.bizmatics.mhfire.service.UnitBeOnDutyService;
import com.bizmatics.mhfire.persistence.mapper.po.UnitBeOnDutyPO;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.*;
import java.util.stream.Collectors;

/**
 * @author yq
 * @date 2021/5/27 15:18
 */
@Service
public class UnitBeOnDutyServiceImpl implements UnitBeOnDutyService {

    @Autowired
    private UnitBeOnDutyMapper unitBeOnDutyMapper;

    @Override
    public List<UnitBeOnDutyPO> getOneByToday() {
        List<UnitBeOnDutyPO> list = new ArrayList<>();
        Date date = new Date();
        Date dayStartTime = DateUtils.getDayStartTime(date);
        Date dayEndTime = DateUtils.getDayEndTime(date);
        List<Map<String, String>> unitBeOnDutyLists = unitBeOnDutyMapper.list(dayStartTime, dayEndTime);
        unitBeOnDutyLists.forEach(stringStringMap -> list.add(enhanceUnitBeOnDutyPo(stringStringMap)));
        return list;
    }

    @Override
    public List<List<UnitBeOnDutyPO>> list(Date startTime, Date endTime) {
        List<List<UnitBeOnDutyPO>> lists = new ArrayList<>();
        List<UnitBeOnDutyPO> list = new ArrayList<>();
        List<Map<String, String>> unitBeOnDutyLists = unitBeOnDutyMapper.list(startTime, endTime);
        unitBeOnDutyLists.forEach(stringStringMap -> list.add(enhanceUnitBeOnDutyPo(stringStringMap)));
        TreeMap<String, List<UnitBeOnDutyPO>> collect = list.stream().collect(Collectors.groupingBy(UnitBeOnDutyPO::getTime, TreeMap::new, Collectors.toList()));
        for (String s:collect.keySet()) {
            lists.add(collect.get(s));
        }
        return lists;
    }



    public UnitBeOnDutyPO enhanceUnitBeOnDutyPo(Map<String,String> unitBeOnDutyMap){
        UnitBeOnDutyPO unitBeOnDutyPo = new UnitBeOnDutyPO();
        unitBeOnDutyPo.setName(unitBeOnDutyMap.get("值班人员姓名"));
        unitBeOnDutyPo.setPostName(unitBeOnDutyMap.get("值班岗位名称"));
        unitBeOnDutyPo.setOrganizationName(unitBeOnDutyMap.get("机构名称"));
        unitBeOnDutyPo.setOrganizationShort(unitBeOnDutyMap.get("机构简称"));
        unitBeOnDutyPo.setOrganizationAddress(unitBeOnDutyMap.get("机构地址"));
        unitBeOnDutyPo.setTime(unitBeOnDutyMap.get("值班日期"));
        return unitBeOnDutyPo;
    }
}
