package com.bizmatics.mhfire.service.util;

import com.bizmatics.common.core.util.HttpUtils;
import com.bizmatics.common.core.util.StringUtils;
import com.bizmatics.mhfire.persistence.mapper.vo.LocateInfo;
import com.fasterxml.jackson.databind.JsonNode;
import com.fasterxml.jackson.databind.ObjectMapper;
import lombok.extern.slf4j.Slf4j;

import java.io.IOException;
import java.net.URLEncoder;
import java.util.ArrayList;
import java.util.List;

/**
 * @author yq
 * @date 2021/7/23 16:10
 */

@Slf4j
public class GouldUtil {

    private static final String GOULD_KEY="b4414402710da7c5fcbb775ec7b83408";



    //申请的账户Key

    /**
     * 0.根据地址名称得到两个地址间的距离
     * @param start 起始位置
     * @param start 结束位置
     * @return 两个地址间的距离
     */
    public long getDistanceByAddress(String start, String end) {
//        String startLonLat = getLonLat(start);
//        String endLonLat = getLonLat(end);
//        long dis = getDistance(startLonLat, endLonLat);
//        return dis;
        return 0;
    }

    /**
     * 1.地址转换为经纬度
     * @param address 地址
     * @return 经纬度
     */
    public static List<LocateInfo> getLonLat(String address) {
        List<LocateInfo> locateInfos = new ArrayList<>();
        try {
            // 返回输入地址address的经纬度信息, 格式是 经度,纬度
            String encode = URLEncoder.encode(address, "UTF-8");
            String queryUrl = "http://restapi.amap.com/v3/geocode/geo?"+"key="+GOULD_KEY+"&address=" + encode+"&batch=true";
            String queryResult = getResponse(queryUrl);
            JsonNode arrNode = new ObjectMapper().readTree(queryResult).get("geocodes");
            if (arrNode.isArray()) {
                for (JsonNode objNode : arrNode) {
                    LocateInfo locateInfo = new LocateInfo();
                    String location = objNode.get("location").asText();
                    if (StringUtils.isNotBlank(location) && !"[]".equals(location)){
                        String[] locations = StringUtils.split(objNode.get("location").asText(), ",");
                        locateInfo.setLongitude(Double.parseDouble(locations[0]));
                        locateInfo.setLatitude(Double.parseDouble(locations[1]));
                        locateInfo.setDistrict(objNode.get("district").asText());
                        locateInfo.setStreet(objNode.get("street").asText());
                    }else {
                        locateInfo.setLongitude(0.00);
                        locateInfo.setLatitude(0.00);
                        locateInfo.setDistrict("");
                        locateInfo.setStreet("");
                    }
                    locateInfos.add(locateInfo);
                }
            }
        }catch (Exception e){
            log.error(e.getMessage());
        }
        return locateInfos;
    }


    /**
     * 将经纬度getLng， getLat 通过getAMapByLngAndLat方法转换地址
     * @param getLng 经度
     * @param getLat 纬度
     * @return 地址名称
     * @throws Exception
     */
    public String getAMapByLngAndLat(String getLng, String getLat){
//        String url;
//        try {
//            url = "http://restapi.amap.com/v3/geocode/regeo?output=JSON&location=" + getLng + "," + getLat
//                    + "&key="+GOULD_KEY+"&radius=0&extensions=base";
//            System.out.println(getLat
//            );
//            System.out.println(url);
//            String queryResult = getResponse(url); // 高德接品返回的是JSON格式的字符串
//            if (queryResult == null) {
//                return "-1";
//            }
//            // 将获取结果转为json 数据
//            JSONObject obj = JSONObject.parseObject(queryResult);
//            if (obj.get("status").toString().equals("1")) {
//                // 如果没有返回-1
//                JSONObject regeocode = obj.getJSONObject("regeocode");
//                if (regeocode.size() > 0) {
//                    // 在regeocode中拿到 formatted_address 具体位置
//                    String formatted = regeocode.get("formatted_address").toString();
//                    return formatted;
//
//                } else {
//                    System.out.println("未找到相匹配的地址！");
//                    return "-1";
//
//                }
//            } else {
//                System.out.println("请求错误！");
//                return "-1";
//            }
//        } catch (Exception e) {
//            // TODO Auto-generated catch block
//            e.printStackTrace();
//        }
//        return "-1";
        return null;
    }

    /**
     * 2.根据两个定位点的经纬度算出两点间的距离
     * @param startLonLat 起始经纬度
     * @param endLonLat 结束经纬度（目标经纬度）
     * @return 两个定位点之间的距离
     */
    private long getDistance(String startLonLat, String endLonLat) {
        // 返回起始地startAddr与目的地endAddr之间的距离，单位：米
//        Long result = new Long(0);
//        String queryUrl = "http://restapi.amap.com/v3/distance?key="+GOULD_KEY+"&origins=" + startLonLat + "&destination="
//                + endLonLat;
//        String queryResult = getResponse(queryUrl);
//        JSONObject job = JSONObject.parseObject(queryResult);
//        JSONArray ja = job.getJSONArray("results");
//        JSONObject jobO = JSONObject.parseObject(ja.getString(0));
//        result = Long.parseLong(jobO.get("distance").toString());
////		System.out.println("距离2：" + result);
//        return result;
        return 1;
    }

    /**
     * 3.发送请求
     * @param serverUrl 请求地址
     */
    private static String getResponse(String serverUrl) {
        // 用JAVA发起http请求，并返回json格式的结果
        String result = "";
        try {
            result = HttpUtils.get(serverUrl, null);
        } catch (IOException e) {
            e.printStackTrace();
        }
        return result;
    }

}
